diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/assert.h ns-3.38/src/core/model/assert.h
--- ns-3.37/src/core/model/assert.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/model/assert.h	2023-03-16 20:54:23.588868400 -0700
@@ -68,7 +68,7 @@
     {                                                                                              \
         if (!(condition))                                                                          \
         {                                                                                          \
-            std::cerr << "assert failed. cond=\"" << #condition << "\", ";                         \
+            std::cerr << "NS_ASSERT failed, cond=\"" << #condition << "\", ";                      \
             NS_FATAL_ERROR_NO_MSG();                                                               \
         }                                                                                          \
     } while (false)
@@ -88,13 +88,17 @@
     {                                                                                              \
         if (!(condition))                                                                          \
         {                                                                                          \
-            std::cerr << "assert failed. cond=\"" << #condition << "\", ";                         \
+            std::cerr << "NS_ASSERT failed, cond=\"" << #condition << "\", ";                      \
             NS_FATAL_ERROR(message);                                                               \
         }                                                                                          \
     } while (false)
 
 #else /* NS3_ASSERT_ENABLE */
 
+// NOTE: The no-op macros are not inserted into the final code.
+// However, the use of sizeof() allows the compiler to silently check if the condition is
+// syntactically valid.
+
 #define NS_ASSERT(condition)                                                                       \
     do                                                                                             \
     {                                                                                              \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/attribute-construction-list.cc ns-3.38/src/core/model/attribute-construction-list.cc
--- ns-3.37/src/core/model/attribute-construction-list.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/model/attribute-construction-list.cc	2023-03-16 20:54:23.588868400 -0700
@@ -54,7 +54,7 @@
         }
     }
     // store the new value.
-    struct Item attr;
+    Item attr;
     attr.checker = checker;
     attr.value = value;
     attr.name = name;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/attribute-container.h ns-3.38/src/core/model/attribute-container.h
--- ns-3.37/src/core/model/attribute-container.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/attribute-container.h	2023-03-16 20:54:23.588868400 -0700
@@ -228,7 +228,7 @@
 Ptr<const AttributeChecker> MakeAttributeContainerChecker(Ptr<const AttributeChecker> itemchecker);
 
 /**
- * Make unitialized AttributeContainerChecker using explicit types.
+ * Make uninitialized AttributeContainerChecker using explicit types.
  * @tparam A AttributeValue type in container.
  * @tparam C Container type returned by Get.
  * \return AttributeContainerChecker.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/attribute-helper.h ns-3.38/src/core/model/attribute-helper.h
--- ns-3.37/src/core/model/attribute-helper.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/attribute-helper.h	2023-03-16 20:54:23.588868400 -0700
@@ -111,7 +111,12 @@
 
         std::string GetValueTypeName() const override
         {
-            return m_type;
+            if (m_type.rfind("ns3::", 0) == 0)
+            {
+                // m_type already starts with "ns3::"
+                return m_type;
+            }
+            return "ns3::" + m_type;
         }
 
         bool HasUnderlyingTypeInformation() const override
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/calendar-scheduler.h ns-3.38/src/core/model/calendar-scheduler.h
--- ns-3.37/src/core/model/calendar-scheduler.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/calendar-scheduler.h	2023-03-16 20:54:23.588868400 -0700
@@ -55,7 +55,7 @@
  * `(ts / m_width) % m_nBuckets`.  This class automatically adjusts
  * the number of buckets to keep the average occupancy around 2.
  * Buckets themselves are implemented as a `std::list<>`, and events are
- * kept sorted withing the buckets.
+ * kept sorted within the buckets.
  *
  * \par Time Complexity
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/callback.h ns-3.38/src/core/model/callback.h
--- ns-3.37/src/core/model/callback.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/callback.h	2023-03-16 20:54:23.588868400 -0700
@@ -441,6 +441,9 @@
 template <typename R, typename... UArgs>
 class Callback : public CallbackBase
 {
+    template <typename ROther, typename... UArgsOther>
+    friend class Callback;
+
   public:
     Callback()
     {
@@ -464,18 +467,17 @@
      * \param [in] bargs The values of the bound arguments
      */
     template <typename... BArgs>
-    Callback(const CallbackBase& cb, BArgs... bargs)
+    Callback(const Callback<R, BArgs..., UArgs...>& cb, BArgs... bargs)
     {
-        auto cbDerived =
-            static_cast<const CallbackImpl<R, BArgs..., UArgs...>*>(PeekPointer(cb.GetImpl()));
-
-        std::function<R(BArgs..., UArgs...)> f(cbDerived->GetFunction());
+        auto f = cb.DoPeekImpl()->GetFunction();
 
-        CallbackComponentVector components(cbDerived->GetComponents());
+        CallbackComponentVector components(cb.DoPeekImpl()->GetComponents());
         components.insert(components.end(), {std::make_shared<CallbackComponent<BArgs>>(bargs)...});
 
         m_impl = Create<CallbackImpl<R, UArgs...>>(
-            [f, bargs...](UArgs... uargs) -> R { return f(bargs..., uargs...); },
+            [f, bargs...](auto&&... uargs) -> R {
+                return f(bargs..., std::forward<decltype(uargs)>(uargs)...);
+            },
             components);
     }
 
@@ -508,7 +510,9 @@
                                             std::make_shared<CallbackComponent<BArgs>>(bargs)...});
 
         m_impl = Create<CallbackImpl<R, UArgs...>>(
-            [f, bargs...](UArgs... uargs) -> R { return f(bargs..., uargs...); },
+            [f, bargs...](auto&&... uargs) -> R {
+                return f(bargs..., std::forward<decltype(uargs)>(uargs)...);
+            },
             components);
     }
 
@@ -525,11 +529,23 @@
      * The integer sequence is 0..N-1, where N is the number of arguments left unbound.
      */
     template <std::size_t... INDEX, typename... BoundArgs>
-    auto BindImpl(std::index_sequence<INDEX...> seq, BoundArgs... bargs)
+    auto BindImpl(std::index_sequence<INDEX...> seq, BoundArgs&&... bargs)
     {
-        return Callback<R, std::tuple_element_t<sizeof...(bargs) + INDEX, std::tuple<UArgs...>>...>(
-            *this,
-            bargs...);
+        Callback<R, std::tuple_element_t<sizeof...(bargs) + INDEX, std::tuple<UArgs...>>...> cb;
+
+        const auto f = DoPeekImpl()->GetFunction();
+
+        CallbackComponentVector components(DoPeekImpl()->GetComponents());
+        components.insert(components.end(),
+                          {std::make_shared<CallbackComponent<BoundArgs>>(bargs)...});
+
+        cb.m_impl = Create<std::remove_pointer_t<decltype(cb.DoPeekImpl())>>(
+            [f, bargs...](auto&&... uargs) mutable {
+                return f(bargs..., std::forward<decltype(uargs)>(uargs)...);
+            },
+            components);
+
+        return cb;
     }
 
   public:
@@ -541,7 +557,7 @@
      * \return The bound callback
      */
     template <typename... BoundArgs>
-    auto Bind(BoundArgs... bargs)
+    auto Bind(BoundArgs&&... bargs)
     {
         static_assert(sizeof...(UArgs) > 0);
         return BindImpl(std::make_index_sequence<sizeof...(UArgs) - sizeof...(BoundArgs)>{},
@@ -749,9 +765,9 @@
  */
 template <typename R, typename... Args, typename... BArgs>
 auto
-MakeBoundCallback(R (*fnPtr)(Args...), BArgs... bargs)
+MakeBoundCallback(R (*fnPtr)(Args...), BArgs&&... bargs)
 {
-    return Callback<R, Args...>(fnPtr).Bind(bargs...);
+    return Callback<R, Args...>(fnPtr).Bind(std::forward<BArgs>(bargs)...);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/command-line.cc ns-3.38/src/core/model/command-line.cc
--- ns-3.37/src/core/model/command-line.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/command-line.cc	2023-03-16 20:54:23.588868400 -0700
@@ -21,6 +21,7 @@
 
 #include "config.h"
 #include "des-metrics.h"
+#include "environment-variable.h"
 #include "global-value.h"
 #include "log.h"
 #include "string.h"
@@ -33,7 +34,7 @@
 
 #include <algorithm> // transform
 #include <cctype>    // tolower
-#include <cstdlib>   // exit, getenv
+#include <cstdlib>   // exit
 #include <cstring>   // strlen
 #include <iomanip>   // setw, boolalpha
 #include <set>
@@ -198,7 +199,7 @@
 
     m_nonOptionCount = 0;
 
-    if (args.size() > 0)
+    if (!args.empty())
     {
         args.erase(args.begin()); // discard the program name
 
@@ -385,8 +386,9 @@
 
     // Hack to show just the declared non-options
     Items nonOptions(m_nonOptions.begin(), m_nonOptions.begin() + m_NNonOptions);
-    os << m_shortName << (m_options.size() ? " [Program Options]" : "")
-       << (nonOptions.size() ? " [Program Arguments]" : "") << " [General Arguments]" << std::endl;
+    os << m_shortName << (!m_options.empty() ? " [Program Options]" : "")
+       << (!nonOptions.empty() ? " [Program Arguments]" : "") << " [General Arguments]"
+       << std::endl;
 
     if (!m_usage.empty())
     {
@@ -461,13 +463,13 @@
 {
     NS_LOG_FUNCTION(this);
 
-    const char* envVar = std::getenv("NS_COMMANDLINE_INTROSPECTION");
-    if (envVar == nullptr || std::strlen(envVar) == 0)
+    auto [found, path] = EnvironmentVariable::Get("NS_COMMANDLINE_INTROSPECTION");
+    if (!found)
     {
         return;
     }
 
-    if (m_shortName.size() == 0)
+    if (m_shortName.empty())
     {
         NS_FATAL_ERROR("No file name on example-to-run; forgot to use CommandLine var (__FILE__)?");
         return;
@@ -476,7 +478,7 @@
     // Hack to show just the declared non-options
     Items nonOptions(m_nonOptions.begin(), m_nonOptions.begin() + m_NNonOptions);
 
-    std::string outf = SystemPath::Append(std::string(envVar), m_shortName + ".command-line");
+    std::string outf = SystemPath::Append(path, m_shortName + ".command-line");
 
     NS_LOG_INFO("Writing CommandLine doxy to " << outf);
 
@@ -484,8 +486,8 @@
 
     os << "/**\n \\file " << m_shortName << ".cc\n"
        << "<h3>Usage</h3>\n"
-       << "<code>$ ./ns3 run \"" << m_shortName << (m_options.size() ? " [Program Options]" : "")
-       << (nonOptions.size() ? " [Program Arguments]" : "") << "\"</code>\n";
+       << "<code>$ ./ns3 run \"" << m_shortName << (!m_options.empty() ? " [Program Options]" : "")
+       << (!nonOptions.empty() ? " [Program Arguments]" : "") << "\"</code>\n";
 
     if (!m_usage.empty())
     {
@@ -691,7 +693,7 @@
 
     auto errorExit = [this, name, value]() {
         std::cerr << "Invalid command-line argument: --" << name;
-        if (value != "")
+        if (!value.empty())
         {
             std::cerr << "=" << value;
         }
@@ -723,7 +725,7 @@
 bool
 CommandLine::CallbackItem::HasDefault() const
 {
-    return m_default != "";
+    return !m_default.empty();
 }
 
 std::string
@@ -759,7 +761,7 @@
 void
 CommandLine::AddValue(const std::string& name,
                       const std::string& help,
-                      ns3::Callback<bool, std::string> callback,
+                      ns3::Callback<bool, const std::string&> callback,
                       const std::string& defaultValue /* = "" */)
 
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/command-line.h ns-3.38/src/core/model/command-line.h
--- ns-3.37/src/core/model/command-line.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/command-line.h	2023-03-16 20:54:23.588868400 -0700
@@ -322,7 +322,7 @@
      */
     void AddValue(const std::string& name,
                   const std::string& help,
-                  ns3::Callback<bool, std::string> callback,
+                  ns3::Callback<bool, const std::string&> callback,
                   const std::string& defaultValue = "");
 
     /**
@@ -533,7 +533,7 @@
         bool HasDefault() const override;
         std::string GetDefault() const override;
 
-        ns3::Callback<bool, std::string> m_callback; /**< The Callback */
+        ns3::Callback<bool, const std::string&> m_callback; /**< The Callback */
         std::string m_default; /**< The default value, as a string, if it exists. */
     };                         // class CallbackItem
 
@@ -777,7 +777,7 @@
 bool
 CommandLine::UserItem<T>::HasDefault() const
 {
-    return (m_default.size() > 0);
+    return !m_default.empty();
 }
 
 template <typename T>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/config.cc ns-3.38/src/core/model/config.cc
--- ns-3.37/src/core/model/config.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/config.cc	2023-03-16 20:54:23.588868400 -0700
@@ -129,7 +129,7 @@
 {
     if (!ConnectFailSafe(name, cb))
     {
-        NS_FATAL_ERROR("Cound not connect callback to " << name);
+        NS_FATAL_ERROR("Could not connect callback to " << name);
     }
 }
 
@@ -605,7 +605,7 @@
 Resolver::DoArrayResolve(std::string path, const ObjectPtrContainerValue& container)
 {
     NS_LOG_FUNCTION(this << path << &container);
-    NS_ASSERT(path != "");
+    NS_ASSERT(!path.empty());
     NS_ASSERT((path.find('/')) == 0);
     std::string::size_type next = path.find('/', 1);
     if (next == std::string::npos)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/deprecated.h ns-3.38/src/core/model/deprecated.h
--- ns-3.37/src/core/model/deprecated.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/deprecated.h	2023-03-16 20:54:51.628957000 -0700
@@ -60,6 +60,15 @@
  *     void SomethingUseful () { ... }
  *     \endcode.
  *
+ * \note Sometimes it is necessary to silence a deprecation warning.
+ * Even though this is highly discouraged, if necessary it is possible to use:
+ * \code
+ *   NS_WARNING_PUSH_DEPRECATED;
+ *   // call to a function or class that has been deprecated.
+ *   NS_WARNING_POP;
+ * \endcode
+ * These macros are defined in warnings.h
+ *
  * \param msg Optional message to add to the compiler warning.
  *
  */
@@ -67,6 +76,13 @@
 
 /**
  * \ingroup core
+ * \def NS_DEPRECATED_3_38
+ * Tag for things deprecated in version ns-3.38.
+ */
+#define NS_DEPRECATED_3_38(msg) NS_DEPRECATED(msg)
+
+/**
+ * \ingroup core
  * \def NS_DEPRECATED_3_37
  * Tag for things deprecated in version ns-3.37.
  */
@@ -79,18 +95,4 @@
  */
 #define NS_DEPRECATED_3_36(msg) NS_DEPRECATED(msg)
 
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_35
- * Tag for things deprecated in version ns-3.35.
- */
-#define NS_DEPRECATED_3_35 NS_DEPRECATED("")
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_34
- * Tag for things deprecated in version ns-3.34.
- */
-#define NS_DEPRECATED_3_34 NS_DEPRECATED("")
-
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/des-metrics.cc ns-3.38/src/core/model/des-metrics.cc
--- ns-3.37/src/core/model/des-metrics.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/des-metrics.cc	2023-03-16 20:54:23.588868400 -0700
@@ -50,17 +50,17 @@
     m_initialized = true;
 
     std::string model_name("desTraceFile");
-    if (args.size() > 0)
+    if (!args.empty())
     {
         std::string arg0 = args[0];
         model_name = SystemPath::Split(arg0).back();
     }
     std::string jsonFile = model_name + ".json";
-    if (outDir != "")
+    if (!outDir.empty())
     {
         DesMetrics::m_outputDir = outDir;
     }
-    if (DesMetrics::m_outputDir != "")
+    if (!DesMetrics::m_outputDir.empty())
     {
         jsonFile = SystemPath::Append(DesMetrics::m_outputDir, jsonFile);
     }
@@ -76,7 +76,7 @@
     m_os << " \"model_name\" : \"" << model_name << "\"," << std::endl;
     m_os << " \"capture_date\" : \"" << capture_date << "\"," << std::endl;
     m_os << " \"command_line_arguments\" : \"";
-    if (args.size() == 0)
+    if (args.empty())
     {
         for (std::size_t i = 0; i < args.size(); ++i)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/environment-variable.cc ns-3.38/src/core/model/environment-variable.cc
--- ns-3.37/src/core/model/environment-variable.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/model/environment-variable.cc	2023-03-16 20:54:23.588868400 -0700
@@ -0,0 +1,275 @@
+/*
+ * Copyright (c) 2022 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "environment-variable.h"
+
+#include "ns3/string.h"
+
+#include <cstdlib>  // std::getenv
+#include <cstring>  // strlen
+#include <iostream> // clog
+#include <stdlib.h> // Global functions setenv, unsetenv
+
+/**
+ * \file
+ * \ingroup core-environ
+ * Class EnvironmentVariable implementation.
+ */
+
+#ifdef __WIN32__
+#include <cerrno>
+
+/**
+ * Windows implementation of the POSIX function `setenv()`
+ *
+ * \param [in] var_name The environment variable to set.
+ *             Must not be a null-pointer, and must not contain `=`.
+ * \param [in] new_value The new value to set \p var_name to.
+ *             Must not by a null pointer or empty.
+ * \param [in] change_flag Must be non-zero to actually change the environment.
+ * \returns 0 if successful, -1 if failed.
+ */
+int
+setenv(const char* var_name, const char* new_value, int change_flag)
+{
+    std::string variable{var_name};
+    std::string value{new_value};
+
+    // In case arguments are null pointers, return invalid error
+    // Windows does not accept empty environment variables
+    if (variable.empty() || value.empty())
+    {
+        errno = EINVAL;
+        return -1;
+    }
+
+    // Posix does not accept '=', so impose that here
+    if (variable.find('=') != std::string::npos)
+    {
+        errno = EINVAL;
+        return -1;
+    }
+
+    // Change flag equals to zero preserves a pre-existing value
+    if (change_flag == 0)
+    {
+        char* old_value = std::getenv(var_name);
+        if (old_value != nullptr)
+        {
+            return 0;
+        }
+    }
+
+    // Write new value for the environment variable
+    return _putenv_s(var_name, new_value);
+}
+
+/**
+ * Windows implementation of the POSIX function `unsetenv()`
+ * \param [in] var_name The environment variable to unset and remove from the environment.
+ * \returns 0 if successful, -1 if failed.
+ */
+int
+unsetenv(const char* var_name)
+{
+    return _putenv_s(var_name, "");
+}
+
+#endif // __WIN32__
+
+namespace ns3
+{
+
+/**
+ * \ingroup core-environ
+ *
+ * \def NS_LOCAL_LOG(msg)
+ * File-local logging macro for environment-variable.cc
+ * Our usual Logging doesn't work here because these functions
+ * get called during static initialization of Logging itself.
+ * \param msg The message stream to log
+ *
+ * \def NS_LOCAL_ASSERT(cond, msg)
+ * File-local assert macro for environment-variable.cc
+ * Our usual assert doesn't work here because these functions
+ * get called during static initialization of Logging itself.
+ * \param cond The condition which is asserted to be \c true
+ * \param msg The message stream to log
+ */
+#if 0
+#define NS_LOCAL_LOG(msg)                                                                          \
+    std::cerr << __FILE__ << ":" << __LINE__ << ":" << __FUNCTION__ << "(): " << msg << std::endl
+
+#define NS_LOCAL_ASSERT(cond, msg)                                                                 \
+    do                                                                                             \
+    {                                                                                              \
+        if (!(cond))                                                                               \
+        {                                                                                          \
+            NS_LOCAL_LOG("assert failed. cond=\"" << #cond << "\", " << msg);                      \
+        }                                                                                          \
+    } while (false)
+
+#else
+#define NS_LOCAL_LOG(msg)
+#define NS_LOCAL_ASSERT(cond, msg)
+#endif
+
+/* static */
+EnvironmentVariable::DictionaryList&
+EnvironmentVariable::Instance()
+{
+    static DictionaryList instance;
+    return instance;
+}
+
+/* static */
+void
+EnvironmentVariable::Clear()
+{
+    Instance().clear();
+}
+
+/* static */
+std::shared_ptr<EnvironmentVariable::Dictionary>
+EnvironmentVariable::GetDictionary(const std::string& envvar, const std::string& delim /* ";" */)
+{
+    NS_LOCAL_LOG(envvar << ", " << delim);
+    std::shared_ptr<Dictionary> dict;
+    auto loc = Instance().find(envvar);
+    if (loc != Instance().end())
+    {
+        NS_LOCAL_LOG("found envvar in cache");
+        dict = loc->second;
+    }
+    else
+    {
+        NS_LOCAL_LOG("envvar not in cache, checking environment");
+        dict = std::make_shared<Dictionary>(envvar, delim);
+        Instance().insert({envvar, dict});
+    }
+
+    return dict;
+}
+
+/* static */
+EnvironmentVariable::KeyFoundType
+EnvironmentVariable::Get(const std::string& envvar,
+                         const std::string& key /* "" */,
+                         const std::string& delim /* ";" */)
+{
+    auto dict = GetDictionary(envvar, delim);
+    return dict->Get(key);
+}
+
+/* static */
+bool
+EnvironmentVariable::Set(const std::string& variable, const std::string& value)
+{
+    int fail = setenv(variable.c_str(), value.c_str(), 1);
+    return !fail;
+}
+
+/* static */
+bool
+EnvironmentVariable::Unset(const std::string& variable)
+{
+    int fail = unsetenv(variable.c_str());
+    return !fail;
+}
+
+EnvironmentVariable::KeyFoundType
+EnvironmentVariable::Dictionary::Get(const std::string& key) const
+{
+    NS_LOCAL_LOG(key);
+
+    if (!m_exists)
+    {
+        return {false, ""};
+    }
+
+    if (key.empty())
+    {
+        // Empty key is request for entire value
+        return {true, m_variable};
+    }
+
+    auto loc = m_dict.find(key);
+    if (loc != m_dict.end())
+    {
+        NS_LOCAL_LOG("found key in dictionary");
+        NS_LOCAL_LOG("found: key '" << key << "', value: '" << loc->second << "'");
+        return {true, loc->second};
+    }
+
+    // key not found
+    return {false, ""};
+}
+
+EnvironmentVariable::Dictionary::Dictionary(const std::string& envvar,
+                                            const std::string& delim /* "=" */)
+{
+    NS_LOCAL_LOG(envvar << ", " << delim);
+
+    const char* envCstr = std::getenv(envvar.c_str());
+    // Returns null pointer if envvar doesn't exist
+    if (!envCstr)
+    {
+        m_exists = false;
+        return;
+    }
+
+    // So it exists
+    m_exists = true;
+    m_variable = envCstr;
+    NS_LOCAL_LOG("found envvar in environment with value '" << m_variable << "'");
+
+    // ...but might be empty
+    if (m_variable.empty())
+    {
+        return;
+    }
+
+    StringVector keyvals = SplitString(m_variable, delim);
+    NS_LOCAL_ASSERT(keyvals.empty(), "Unexpected empty keyvals from non-empty m_variable");
+    for (const auto& keyval : keyvals)
+    {
+        if (keyval.empty())
+        {
+            continue;
+        }
+
+        std::size_t equals = keyval.find_first_of('=');
+        std::string key{keyval, 0, equals};
+        std::string value;
+        if (equals < keyval.size() - 1)
+        {
+            value = keyval.substr(equals + 1, keyval.size());
+        }
+        NS_LOCAL_LOG("found key '" << key << "' with value '" << value << "'");
+        m_dict.insert({key, value});
+    }
+}
+
+EnvironmentVariable::Dictionary::KeyValueStore
+EnvironmentVariable::Dictionary::GetStore() const
+{
+    return m_dict;
+}
+
+} // namespace ns3
